﻿// Graph width.
var maxHistory	= 112;
// Timer interval in ms for query and refresh.
var refreshRate	= 1000;
// GUI constants.
var driveHeight = 65
var topMargin = 6 + 20;
var bottomMargin = 4+13;
// History of values for graphing purposes.
var history = {};
// Stuff to interface with system monitor.
var locator = new ActiveXObject("WbemScripting.SWbemLocator");
var service = locator.ConnectServer(null, "root\\cimv2");
// Excluded drive letters saved in a bit mask with A = 1, B = 2, C = 4 and so on.
var excludedDrivesMask;
// Change mode between logical and physical disks.
var diskmode;
var size;
var sizechange;
var setsizechange;

System.Gadget.settingsUI = "settings.html";
 
document.onselectstart = function() {return false;};

function onLoad() {
 size = System.Gadget.Settings.read("SetSize");
 if (size == '') {
  size = "1";
  System.Gadget.Settings.write("SetSize", size);
  System.Gadget.Settings.write("SizeChange", size);
 } 
 
 diskmode = System.Gadget.Settings.read("WhichDrivesICanSee");
 if (diskmode == '') {
  diskmode = "0";
  System.Gadget.Settings.write("WhichDrivesICanSee", diskmode);
 }
 
 excludedDrivesMask = System.Gadget.Settings.read("ExcludedDrives");
 refresh();
 window.setInterval("refresh();", refreshRate);
}

function compareDriveLetters(a, b) {
	return a.charCodeAt(0) - b.charCodeAt(0);
}

function fixedDigits(value) {
    if (value > 1000)
        return value.toFixed(0);
    else if (value > 100)
        return value.toFixed(1);
    else if (value > 10)
        return value.toFixed(2);
    else
        return value.toFixed(3);    
}

function formatBytes(bytes) {
    if (bytes > 1073741824)
        return fixedDigits(bytes / 1024 / 1024 / 1024) + "Г";
    if (bytes > 1048576)
        return fixedDigits(bytes / 1024 / 1024) + "M";
    if (bytes > 1024)
        return fixedDigits(bytes / 1024) + "K";
        
    return fixedDigits(bytes);    
}

function getMax(history) {
  var max = 0;
  for (h in history) {
    if (history[h].read > max) {
      max = history[h].read;
    }
    if (history[h].write > max) {
      max = history[h].write;
    }
  }  
  return max;
}

function refresh() {
 setsizechange = false;
 size = System.Gadget.Settings.read("SetSize");
 sizechange = System.Gadget.Settings.read("SizeChange");
 if (size != sizechange)
  { 
   System.Gadget.Settings.write("SizeChange", size);
   setsizechange = true;
  }
  
 try{
  var resultSet = null;
  diskmode = System.Gadget.Settings.read("WhichDrivesICanSee");
  if (diskmode == "1") resultSet = service.ExecQuery("SELECT * FROM Win32_PerfFormattedData_PerfDisk_LogicalDisk");
  else  resultSet = service.ExecQuery("SELECT * FROM Win32_PerfFormattedData_PerfDisk_PhysicalDisk");

  for (var drive in history) { history[drive].inuse = false; }
    
  var driveNames = [];
  var driveChange = false;
  for (var i = 0; i < resultSet.Count; i++) {
  if (resultSet.ItemIndex(i).Name != "_Total") {
   var drive = resultSet.ItemIndex(i).Name.substring(resultSet.ItemIndex(i).Name.indexOf(" ") + 1);
   var mask = parseInt(System.Gadget.Settings.read("ExcludedDrives"));
   var letter = drive.charAt(0);        
   if (!isNaN(mask) && letterInMask(letter, mask)) { continue; }
        
   driveNames.push(drive);
        
   if (!(drive in history)) {
    driveChange = true;
    history[drive] = {};
    history[drive].drive = drive;
    history[drive].inuse = true;
    history[drive].history = [];
    for (var j = 0; j < maxHistory; j++) {
     var zero = {};
     zero.active = 0;
     zero.read = 0;
     zero.write = 0;
     history[drive].history.push(zero);
    }
   }
                    
  var temp = {};
  temp.active = Number(resultSet.ItemIndex(i).PercentDiskTime);
  temp.read = Number(resultSet.ItemIndex(i).DiskReadBytesPerSec);
  temp.write = Number(resultSet.ItemIndex(i).DiskWriteBytesPerSec);
   history[drive].inuse = true;
  history[drive].history.push(temp);
  history[drive].history.shift();
 }
 }
	
 for (var drive in history) {
  if (!history[drive].inuse) {
   driveChange = true;
    delete history[drive];
  }
 }
  
 if ((driveChange) || (setsizechange)) {

  if (driveChange) {
   driveNames.sort(compareDriveLetters);
   for (var i = 0; i < driveNames.length; i++)
    history[driveNames[i]].index = i;
  }  

  var html = '<g:background src="images/background' + (driveNames.length < 1 ? 1 : (driveNames.length > 15 ? 15 : driveNames.length)) + '.png" style="width:' +
  parseInt(130 * size) + 'px;height:' + parseInt((topMargin + Math.max(1, driveNames.length) * driveHeight + bottomMargin) * size) + 'px">';
  html += '<g:text style="position:absolute;top:' + parseInt(6 * size) + 'px;width:100%;text-align:center;font-size:' + parseInt(12 * size) +
  'px;color:#FFFFFF;font-weight:bold;">Монитор дисков</g:text>';
  html += '<g:text style="position:absolute;top:' + parseInt(16 * size) + 'px;width:100%;"><hr align="center" width="76%" color="#808080"></g:text>'
		
  for (var i = 0; i < driveNames.length; i++) {
   html += '<g:text style="font-weight:bold;top:' + parseInt((topMargin + i * driveHeight) * size) + 'px;left:' + parseInt(7 * size) + 'px;font-size:' +
   parseInt(9 * size) + 'px">';
   if (diskmode == "1") {
    var drivelabel = getlabel(driveNames[i]);
    html += driveNames[i] + "<span style='font-weight:normal'>" + drivelabel + "</span>";
   }
   else html += driveNames[i];
   html += "</g:text>";
			
   html += '<g:text id="disk' + i + 'activetext" style="top:' + parseInt((topMargin + i * driveHeight) * size) + 'px;left:' + parseInt(100 * size) +
   'px;color:#87CEFA;font-size:' + parseInt(9 * size) + 'px;" />';
   html += '<img src="images/up.png" style="position:absolute;top:' + parseInt((topMargin + i * driveHeight + 14) * size) + 'px;left:' + parseInt(7 * size) +
   'px;width:' + parseInt(7 * size) + ';height:' + parseInt(7 * size) + '" />';
   html += '<g:text id="disk' + i + 'readtext" style="top:' + parseInt((topMargin + i * driveHeight + 11) * size) + 'px;left:' + parseInt(15 * size) +
   'px;color:LightGreen;font-size:' + parseInt(9 * size) + 'px;" />';
   html += '<img src="images/down.png" style="position:absolute;top:' + parseInt((topMargin + i * driveHeight + 14) * size) + 'px;left:' + parseInt(64 * size) +
   'px;width:' + parseInt(7 * size) + ';height:' + parseInt(7 * size) + '" />';
   html += '<g:text id="disk' + i + 'writetext" style="top:' + parseInt((topMargin + i * driveHeight + 11) * size) + 'px;left:' + parseInt(72 * size) +
   'px;color:yellow;font-size:' + parseInt(9 * size) + 'px;" />';

   html += '<div style="position:absolute;top:' + parseInt((topMargin + i * driveHeight + 27) * size) + 'px;left:' + parseInt(5 * size) + 'px;width:' +
   parseInt(119 * size) + 'px;height:' + parseInt(36 * size) + 'px;background-color:black;"></div>'
   html += '<v:shape style="width:' + parseInt(112 * size) + ';height:' + parseInt(30 * size) + 'px;top:' + parseInt((topMargin + i * driveHeight + 29) * size) +
   'px;left:' + parseInt(8 * size) + 'px;position:absolute;" filled="false" strokecolor="#778899" strokeweight="1pt"' +
   ' coordorigin="0 0" coordsize="112 30" path="m 0,30 l 112,30 l 112,0 l 0,0 l 0,30" />';				
   html += '<v:shape style="width:' + parseInt(112 * size) + ';height:' + parseInt(30 * size) + 'px;top:' + parseInt((topMargin + i * driveHeight + 29) * size) +
   'px;left:' + parseInt(8 * size) + 'px;position:absolute;" filled="false" strokecolor="#2F4F4F" strokeweight="1pt"' +
   ' coordorigin="0 0" coordsize="112 30" path=" m 6,30 l 6,0  m 16,30 l 16,0  m 26,30 l 26,0  m 36,30 l 36,0  m 46,30 l 46,0  m 56,30 l 56,0  m 66,30 l 66,0  m 76,30 l 76,0  m 86,30 l 86,0  m 96,30 l 96,0  m 106,30 l 106,0 "/>';
   html += '<v:shape style="width:' + parseInt(112 * size) + ';height:' + parseInt(30 * size) + 'px;top:' + parseInt((topMargin + i * driveHeight + 29) * size) +
   'px;left:' + parseInt(8 * size) + 'px;position:absolute;" filled="false" strokecolor="#2F4F4F" strokeweight="1pt"' +
   ' coordorigin="0 0" coordsize="112 30" path=" m 0,5 l 112,5  m 0,10 l 112,10  m 0,15 l 112,15  m 0,20 l 112,20  m 0,25 l 112,25"/>';

   html += '<v:shape id="disk' + i + 'activegraph" style="width:' + parseInt(112 * size) + ';height:' + parseInt(30 * size) + 'px;top:' +
   parseInt((topMargin + i * driveHeight + 29) * size) + 'px;left:' + parseInt(8 * size) + 'px;position:absolute;" filled="false" strokecolor="#87CEFA" ' +
   'strokeweight="1pt" fillcolor="#87CEFA" coordorigin="0 0" coordsize="112 100"/>';
   html += '<v:shape id="disk' + i + 'readgraph" style="width:' + parseInt(112 * size) + ';height:' + parseInt(30 * size) + 'px;top:' +
   parseInt((topMargin + i * driveHeight + 29) * size) + 'px;left:' + parseInt(8 * size) + 'px;position:absolute;" filled="false" strokecolor="#7EE444" ' +
   'strokeweight="1pt" fillcolor="#7EE444" coordorigin="0 0" coordsize="112 100"/>';
   html += '<v:shape id="disk' + i + 'writegraph" style="width:' + parseInt(112 * size) + ';height:' + parseInt(30 * size) + 'px;top:' +
   parseInt((topMargin + i * driveHeight + 29) * size) + 'px;left:' + parseInt(8 * size) + 'px;position:absolute;" filled="false" strokecolor="#FFF62A" ' +
   'strokeweight="1pt" fillcolor="#FFF62A" coordorigin="0 0" coordsize="112 100"/>';

   html += '<g:text style="top:' +  parseInt((topMargin + i * driveHeight + 26) * size) + 'px;left:' + parseInt(8 * size) + 'px;width:' + parseInt(45 * size) +
   'px;height:' + parseInt(9 * size) + 'px;color:white;background-color:#040505;filter:alpha(opacity=60);border:' + parseInt(1 * size) + 'px solid #2F4F4F;" />' +
   '<g:text id="disk' + i + 'graphmax" style="top:' +  parseInt((topMargin + i * driveHeight + 26) * size) + 'px;left:' + parseInt(8 * size) +
   'px;color:white;font-size:' + parseInt(9 * size) + 'px;" />';
  }//end for

  html += '<g:text id="advertis" style="position:absolute;width:100%;top:' + parseInt((Math.max(1, driveNames.length) * driveHeight + 24) * size) + 'px;left:' +
  parseInt(10 * size) + 'px;font-size:' + parseInt(10 * size) + 'px;"><a class="ads" href="http://www.shvaika.ic.ck.ua" target="_blank">&copy; 2010 by Igogo</a></g:text>'
  html += '<g:text id="versionnumber" style="position:absolute;font-size:' + parseInt(9 * size) + 'px;top:' +
  parseInt((Math.max(1, driveNames.length) * driveHeight + 24) * size) + 'px;left:0px;width:' + parseInt(120 * size) + 'px;text-align:right;color:#C0C0C0;">v3.0</g:text>'

  document.body.style.width = parseInt(130 * size) + "px";
  document.body.style.height = parseInt((topMargin + Math.max(1, driveNames.length) * driveHeight + bottomMargin) * size) + "px";
  document.body.innerHTML = html + "</g:background>";
 }//end if 

 for (var drive in history) {	
  var max = getMax(history[drive].history);
  if (max == 0) { max = 1; }	
  document.getElementById("disk" + history[drive].index + "activetext").innerHTML = history[drive].history[maxHistory - 1].active + "%";
  document.getElementById("disk" + history[drive].index + "readtext").innerHTML = formatBytes(history[drive].history[maxHistory - 1].read) + "б/с";
  document.getElementById("disk" + history[drive].index + "writetext").innerHTML = formatBytes(history[drive].history[maxHistory - 1].write) + "б/с";
  document.getElementById("disk" + history[drive].index + "graphmax").innerHTML = formatBytes(max) + "б/с";
    
  var activePath = "m 0,100 ";
  var readPath = "m 0,100 ";
  var writePath = "m 0,100 ";
  for (var i = 0; i < maxHistory; i++) {
   activePath += " l " + (i + 1) + "," + (100 - history[drive].history[i].active);
   readPath += " l " + (i + 1) + "," + parseInt(100 * (1 - 1.0 * history[drive].history[i].read / max));
   writePath += " l " + (i + 1) + "," + parseInt(100 * (1 - 1.0 * history[drive].history[i].write / max));
  }
  activePath += " e";
  readPath += " e";
  writePath += " e";
    
  document.getElementById("disk" + history[drive].index + "activegraph").path = activePath;
  document.getElementById("disk" + history[drive].index + "readgraph").path = readPath;
  document.getElementById("disk" + history[drive].index + "writegraph").path = writePath;
 }// end for
} //end try
catch (e) 
 {
  var errhtml = '<g:background src="images/background0.png" style="width:' + parseInt(130 * size) + 'px;height:' + parseInt(98 * size) + 'px">';
  errhtml += '<g:text style="position:absolute;top:' + parseInt(6 * size) + 'px;width:100%;text-align:center;font-size:' + parseInt(12 * size) +
  'px;color:#FFFFFF;font-weight:bold;">Drives Monitor</g:text>';
  errhtml += '<g:text style="position:absolute;top:' + parseInt(16 * size) + 'px;width:100%;"><hr align="center" width="68%" color="#808080"></g:text>'
  errhtml += '<img src="images/nowmi24.png" style="position:absolute;top:' + parseInt(26 * size) + 'px;left:' + parseInt(53 * size) +
  'px;width:' + parseInt(24 * size) + ';height:' + parseInt(24 * size) + '" />';
  errhtml += '<g:text style="position:absolute;top:' + parseInt(50 * size) + 'px;width:100%;font-size:' + parseInt(12 * size) +
  'px;text-align:center;color:#FF0000;font-weight:bold;">No WMI info<br>for drives!</g:text>';
  errhtml += '<g:text id="advertis" style="position:absolute;width:100%;top:' + parseInt(78 * size) + 'px;left:' + parseInt(10 * size) +
  'px;font-size:' + parseInt(10 * size) + 'px"><a class="ads" href="http://www.shvaika.ic.ck.ua" target="_blank">&copy; 2010 by Igogo</a></g:text>'
  errhtml += '<g:text id="versionnumber" style="position:absolute;font-size:' + parseInt(9 * size) + 'px;top:' + parseInt(78 * size) +
  'px;left:0px;width:' + parseInt(120 * size) + 'px;text-align:right;color:#C0C0C0;">v3.0</g:text>'
  document.body.style.width = parseInt(130 * size) + "px";  
  document.body.style.height = parseInt(98 * size) + "px";
  document.body.innerHTML = errhtml + "</g:background>";
 }//end catch
}//end function

function getlabel(driveLetter){
 var disklabel;
 try{
  var drive = System.Shell.drive(driveLetter);
  if (drive.isReady) disklabel = " " + drive.volumeLabel;
 } //end try
 catch(e){
  disklabel = "";
 }
 return disklabel;
}

function letterInMask(letter, mask) {
  var letterValue = Math.pow(2, letter.charCodeAt(0) - 65);
  return ((letterValue & mask) == letterValue);
}

function runExplorer(){
 System.Shell.execute("explorer.exe", "/n,");
}